#!/usr/bin/env python

"""
CGI adapter.
"""

import WebStack.CGI
import sys, os

def respond(resource, authenticator=None):

    """
    Dispatch to the root application-specific 'resource'. Employ the optional
    'authenticator' to control access to the resource.
    """

    trans = WebStack.CGI.Transaction(sys.stdin, sys.stdout, os.environ)

    try:
        if authenticator is None or authenticator.authenticate(trans):
            resource.respond(trans)
        else:
            trans.set_response_code(401) # Unauthorized
            trans.set_header_value("WWW-Authenticate", '%s realm="%s"' % (
                authenticator.get_auth_type(), authenticator.get_realm()))
    finally:
        trans.commit()

# vim: tabstop=4 expandtab shiftwidth=4
